#pragma once

#include "../core/utils/utils.h"
#include "../core/debug/evemon.h"
#include "../core/debug/exception.h"
#include "../core/math/symbolic/var.h"
#include "../core/math/optics/paraxial/abcd.h"
#include "../core/math/optics/paraxial/yu.h"
#include "../core/math/optics/paraxial/seidel.h"
#include "../core/math/optics/system/base.h"
#include "../core/math/optics/system/group.h"

#include "refractive.h"
#include "thickness.h"

/* thicklens element class */
template<typename type> class thicklens : public math::optics::system::group<type>
{
public:
	thicklens(const math::symbolic::var<type>& radius1, const math::symbolic::var<type>& radius2, const math::symbolic::var<type>& thickness, const math::symbolic::var<type>& lens_index, const math::symbolic::var<type>& medium_index)
	{
		this->push_back(std::make_shared<refractive_surface<type>>(radius1, medium_index, lens_index));
		this->push_back(std::make_shared<thickness_surface<type>>(thickness));
		this->push_back(std::make_shared<refractive_surface<type>>(radius2, lens_index, medium_index));
	}
};